unit COMThread;

interface

uses
  Classes, Windows, HighResTimer_non_v, SmallPort_non_v;

type

  TCOMData = array of array[0..1] of double;

  TCOMThread = class(TThread)
  private
    { Private declarations }
    H:HWND;
    SPort:TSmallPort;
    COMData: TCOMData;
    COMMeasureTime:Cardinal;

    Timer:THighResTimer;
  protected
    procedure Execute; override;
  public
    constructor Create(CreateSuspended: Boolean; MeasureTime:Cardinal; var Data: TCOMData);
  end;

implementation

uses SysUtils;

{ TCOMThread }

constructor TCOMThread.Create(CreateSuspended: Boolean; MeasureTime:Cardinal; var Data: TCOMData);
begin
  inherited Create(CreateSuspended);

  COMData:=Data;
  COMMeasureTime:=MeasureTime;
end;

procedure TCOMThread.Execute;
const
  Base=$3F8;

var
  STime:Cardinal;
  D:Byte;
  I:integer;
begin
  Priority:=tpTimeCritical;

  SPort:=TSmallPort.Create;
  H:=CreateFile('COM1',GENERIC_READ or GENERIC_WRITE, 0, nil,
    OPEN_EXISTING, 0, 0);

  Timer:=THighResTimer.Create;
  Timer.Accuracy:=0;
  Timer.Resolution:=0;
  Timer.ThreadClass:=tcHigh;
  Timer.ThreadPriority:=tpTimeCritical;
  if Timer.TSC then Timer.UseTSC:=true;

  with SPort do begin
    OpenDriver;
    WriteByte(Base+3,$83);
    WriteWord(Base,$0001);
    WriteByte(Base+3,$3);
  end;

  SetLength(ComData,1000000);
  I:=0;

  STime:=GetTickCount;
  Timer.Enabled:=true;

  while ((GetTickCount-STime)<COMMeasureTime) do begin
    //RTS
    D:=SPort.ReadByte(Base+4);
    SPort.WriteByte(Base+4,D or $02);

    //DCD
    D:=SPort.ReadByte(Base+6);
    D:=D and $80;
    D:=D shr 7;
    COMData[I,0]:=D;
    ComData[I,1]:=Timer.GetCountValue;
  end;

  CloseHandle(H);
end;

end.
