unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, RzEdit, RzSpnEdt,
  ComCtrls, HighResTimer, ActnList, Unit2, RzButton, RzPanel,
  Jpeg, INIFiles, gifImage, SmallPort, RzCmboBx, Mask, ExtDlgs, ImgList,
  Buttons, RzTrkBar, XPMan, RzTabs, AppEvnts;

type
  TMainWindow = class(TForm)
    StartTimer: TTimer;
    ScrollBox1: TScrollBox;
    Image: TImage;
    HighResTimer1: THighResTimer;
    ActionList1: TActionList;
    About: TAction;
    RzPanel1: TRzPanel;
    SaveImgButton: TRzToolButton;
    ImageList1: TImageList;
    SavePictureDialog1: TSavePictureDialog;
    SPort: TSmallPort;
    Panel1: TPanel;
    StopButton: TButton;
    StartButton: TButton;
    StaticText10: TStaticText;
    Label3: TLabel;
    Label6: TLabel;
    Label5: TLabel;
    Label2: TLabel;
    Label1: TLabel;
    Label4: TLabel;
    StatusBar1: TStatusBar;
    ColorDialog: TColorDialog;
    RzToolButton1: TRzToolButton;
    TrackBar2: TRzTrackBar;
    XPManifest1: TXPManifest;
    TrackBar1: TRzTrackBar;
    SaveImage: TAction;
    RzGroupBox1: TRzGroupBox;
    PageControl: TRzPageControl;
    TabSheet3: TRzTabSheet;
    StaticText1: TStaticText;
    PortComboBox: TRzComboBox;
    StaticText2: TStaticText;
    StaticText5: TStaticText;
    CaptureTime: TRzSpinEdit;
    AdrButton: TButton;
    AdrText: TStaticText;
    GroupBox2: TGroupBox;
    HoldRTS: TCheckBox;
    HoldDTR: TCheckBox;
    CBUseTSC: TCheckBox;
    GroupBox5: TGroupBox;
    CTS_Start: TCheckBox;
    DSR_Start: TCheckBox;
    RI_Start: TCheckBox;
    DCD_Start: TCheckBox;
    TabSheet4: TRzTabSheet;
    PixPmsSpin: TRzSpinEdit;
    StaticText6: TStaticText;
    PixPmsDiv: TRzSpinEdit;
    StaticText13: TStaticText;
    GroupBox3: TGroupBox;
    StaticText8: TStaticText;
    VGridSp: TRzSpinEdit;
    VGridCap: TCheckBox;
    VGridEven: TCheckBox;
    ShowGrid: TCheckBox;
    GridInMCS: TRadioButton;
    GridInMS: TRadioButton;
    GroupBox4: TGroupBox;
    DCDColor: TRzToolButton;
    RIColor: TRzToolButton;
    DSRColor: TRzToolButton;
    CTSColor: TRzToolButton;
    CTS_Enabled: TCheckBox;
    DSR_Enabled: TCheckBox;
    RI_Enabled: TCheckBox;
    DCD_Enabled: TCheckBox;
    CTS_Inv: TCheckBox;
    DSR_Inv: TCheckBox;
    RI_Inv: TCheckBox;
    DCD_Inv: TCheckBox;
    procedure StartButtonClick(Sender: TObject);
    procedure StopButtonClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure StartTimerTimer(Sender: TObject);
    procedure RenderOnChange(Sender: TObject);
    procedure TrackBarChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure AboutExecute(Sender: TObject);
    procedure SaveImgButtonClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure CaptureTimeChange(Sender: TObject);
    procedure PortComboBoxChange(Sender: TObject);
    procedure AdrButtonClick(Sender: TObject);
    procedure CBUseTSCClick(Sender: TObject);
    procedure DCDColorClick(Sender: TObject);
    procedure ImageMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ImageMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure TimeSelectorClick(Sender: TObject);
    procedure SaveImageExecute(Sender: TObject);
  private
    { Private declarations }
    MeasureTime:Cardinal;
    EndTime:Cardinal;
    //Divider:Extended;
    Aborted:boolean;
    Base:Word;
    Data: array of array[0..1] of double;
    H:HWND;
    procedure RenderGraph;
  public
    { Public declarations }
  end;

var
  MainWindow: TMainWindow;

implementation

uses Types;

{$R *.dfm}

procedure TMainWindow.StartButtonClick(Sender: TObject);
var
  STime:Cardinal;
  D,D1,WR,HoldByte:Byte;
  I:integer;
  WaitMask:byte;
  Time:Double;
begin
  StartButton.Enabled:=false;  // 
  StopButton.Enabled:=true;
  PageControl.Enabled:=false;

  Aborted:=false; // -

  H:=CreateFile(PChar(PortComboBox.Items.Strings[PortComboBox.ItemIndex]),GENERIC_READ or GENERIC_WRITE, 0, nil,
    OPEN_EXISTING, 0, 0);

  SetLength(Data,1);
  Data[0,0]:=0;
  Data[0,1]:=0;
  I:=1;

  //D:=0;
  //D1:=0;

  //     
  WaitMask:=$0;
  if CTS_Start.Checked then WaitMask:=WaitMask or $10;
  if DSR_Start.Checked then WaitMask:=WaitMask or $20;
  if RI_Start.Checked then WaitMask:=WaitMask or $40;
  if DCD_Start.Checked then WaitMask:=WaitMask or $80; 

  // 
  with SPort do begin
    OpenDriver;
    WriteByte(Base+3,$83);
    WriteWord(Base,$0001);
    WriteByte(Base+3,$3);
  end;

  HoldByte:=0;
  WR:=SPort.ReadByte(Base+4);
  SPort.WriteByte(Base+4,WR and $FC);
  if HoldRTS.Checked then HoldByte:=HoldByte or $02;
  if HoldDTR.Checked then HoldByte:=HoldByte or $01;

  // ,   .
  StartTimer.Enabled:=true;
  While StartTimer.Enabled and (Aborted = false) do begin
    // 
    WR:=SPort.ReadByte(Base+4);
    SPort.WriteByte(Base+4,WR or HoldByte);
    Application.ProcessMessages;
  end;
 
  //  .
  D:=SPort.ReadByte(Base+6) and WaitMask;
  //D1:=D and WaitMask;

  repeat
    Application.ProcessMessages;

    WR:=SPort.ReadByte(Base+4);
    SPort.WriteByte(Base+4,WR or HoldByte);

    D1:=SPort.ReadByte(Base+6);
    D1:=D1 and WaitMask;
  until (D<>D1) or Aborted;

  //   RTS / DTR
  WR:=SPort.ReadByte(Base+4);
  SPort.WriteByte(Base+4,WR or $02);

  // 
  HighResTimer1.Enabled:=true;
  HighResTimer1.StartTimeMeasure;
  STime:=GetTickCount;

  while ((GetTickCount-STime)<MeasureTime) and (not Aborted) do begin
    //RTS / DTR
    SPort.WriteByte(Base+4,WR);
    //
    D:=SPort.ReadByte(Base+6);
    if D<>D1 then begin
      HighResTimer1.StopTimeMeasure;
      Time:=HighResTimer1.GetTimeDifference;
      HighResTimer1.StartTimeMeasure;
      SetLength(Data, I+1);
      Data[I,0]:=Time+Data[I-1,0];
      Data[I,1]:=D;
      D1:=D;
      Inc(I);
    end;
  end;

  EndTime:=GetTickCount;

  HighResTimer1.StopTimeMeasure;

  Time:=HighResTimer1.GetTimeDifference;
  SetLength(Data, I+1);
  Data[I,0]:=Time+Data[I-1,0];
  Data[I,1]:=0;

  HighResTimer1.Enabled:=false;

  SPort.CloseDriver;
  CloseHandle(H);
  StaticText10.Color:=clBtnFace;
  StartButton.Enabled:=true;
  StopButton.Enabled:=false;
  PageControl.Enabled:=true;
  StatusBar1.Panels[2].Text:='  : '+IntToStr(EndTime-STime)+' ms';
  TrackBar1.Max:=Round(Data[High(Data),0]);
  TrackBar2.Max:=Round(Data[High(Data),0]);
  if not Aborted then RenderGraph;
end;

procedure TMainWindow.StopButtonClick(Sender: TObject);  //
begin
  Aborted:=true;
end;

procedure TMainWindow.RenderGraph;      // 
const
  PenAmp=40;
  GSpace=15;
var
  PixPms:single;
  i:integer;
  D:byte;
  tmpTime:cardinal;
begin
  tmptime:=GetTickCount;

  PixPms:=PixPmsSpin.Value/PixPmsDiv.Value;

  if High(Data)>-1 then begin

    Image.Picture.Bitmap.PixelFormat:=pf8bit;
    Image.Picture.Bitmap.Width:=Round(Data[High(Data),0]*PixPms);
    Image.Width:=Round(Data[High(Data),0]*PixPms);
    Image.Picture.Bitmap.Height:=Image.Height;

    with Image.Picture.Bitmap.Canvas do begin // 
      Brush.Color:=clWhite;
      Pen.Color:=clWhite;
      Pen.Width:=1;
      Rectangle(0,0,Image.Width,Image.Height);
    end;

    if ShowGrid.Checked then begin //  

      // 

      with Image.Picture.Bitmap.Canvas do begin
        Brush.Color:=clWhite;
        Pen.Color:=clBlue;
      end;

      for i:=1 to 4 do
        with Image.Picture.Bitmap.Canvas do begin
          PenPos:=Point(0,(PenAmp+GSpace)*i);
          LineTo(Image.Width,(PenAmp+GSpace)*i);
        end;

      with Image.Picture.Bitmap.Canvas do begin
        // 

        for i:=0 to (Round(Data[High(Data),0]) div Round(VGridSP.Value)) do begin
          PenPos:=Point(i*Round(VGridSP.Value*PixPms),0);
          LineTo(i*Round(VGridSP.Value*PixPms),Image.Height);

          if VGridCap.Checked then    // 
            if not VGridEven.Checked then  //  
              if GridInMCS.Checked then // /
                TextOut(i*Round(VGridSP.Value*PixPms),0,FloatToStr(i*Round(VGridSP.Value)) + ' ')
                else TextOut(i*Round(VGridSP.Value*PixPms),0,FloatToStr(i*Round(VGridSP.Value)/1000) + ' ')
            else  // 
              if not Odd(i) then
                if GridInMCS.Checked then // /
                  TextOut(i*Round(VGridSP.Value*PixPms),0,FloatToStr(i*Round(VGridSP.Value)) + ' ')
                  else TextOut(i*Round(VGridSP.Value*PixPms),0,FloatToStr(i*Round(VGridSP.Value)/1000) + ' ')
        end;
      end;

      end;

      // 

      //CTS

      if CTS_Enabled.Checked then begin

        with Image.Picture.Bitmap.Canvas do begin
          Brush.Color:=CTSColor.Color;
          Pen.Width:=0;
          Pen.Color:=CTSColor.Color;
        end;

        for i:=0 to High(Data)-1 do begin
          //
          if CTS_Inv.Checked=false then D:=Byte(Round(Data[i,1])) and $10
            else begin
              D:=Byte(Round(Data[i,1]));
              D:=(not D) and $10;
            end;
           if D > 0 then
             Image.Picture.Bitmap.Canvas.Rectangle(Round(Data[i,0]*PixPms),PenAmp+GSpace,Round(Data[i+1,0]*PixPms),GSpace);
        end;
      end;


      //DSR

      if DSR_Enabled.Checked then begin

        with Image.Picture.Bitmap.Canvas do begin
          Brush.Color:=DSRColor.Color;
          Pen.Width:=1;
          Pen.Color:=DSRColor.Color;
        end;

        for i:=0 to High(Data)-1 do begin
          //
          if DSR_Inv.Checked=false then D:=Byte(Round(Data[i,1])) and $20
            else begin
              D:=Byte(Round(Data[i,1]));
              D:=(not D) and $20;
            end;
           if D > 0 then
             Image.Picture.Bitmap.Canvas.Rectangle(Round(Data[i,0]*PixPms),(PenAmp+GSpace)*2,Round(Data[i+1,0]*PixPms),GSpace*2+PenAmp);
        end;
      end;

      //RI
      if RI_Enabled.Checked then begin

        with Image.Picture.Bitmap.Canvas do begin
          Brush.Color:=RIColor.Color;
          Pen.Width:=1;
          Pen.Color:=RIColor.Color;
        end;

        for i:=0 to High(Data)-1 do begin
          //
          if RI_Inv.Checked=false then D:=Byte(Round(Data[i,1])) and $40
            else begin
              D:=Byte(Round(Data[i,1]));
              D:=(not D) and $40;
            end;
           if D > 0 then
            Image.Picture.Bitmap.Canvas.Rectangle(Round(Data[i,0]*PixPms),(PenAmp+GSpace)*3,Round(Data[i+1,0]*PixPms),(PenAmp+GSpace)*3-PenAmp);
        end;
      end;

      //DCD
      if DCD_Enabled.Checked then begin

        with Image.Picture.Bitmap.Canvas do begin
          Brush.Color:=DCDColor.Color;
          Pen.Width:=1;
          Pen.Color:=DCDColor.Color;
        end;

        for i:=0 to High(Data)-1 do begin
          //
          if DCD_Inv.Checked=false then D:=Byte(Round(Data[i,1])) and $80
            else begin
              D:=Byte(Round(Data[i,1]));
              D:=(not D) and $80;
            end;
           if D > 0 then
            Image.Picture.Bitmap.Canvas.Rectangle(Round(Data[i,0]*PixPms),(PenAmp+GSpace)*4,Round(Data[i+1,0]*PixPms),(PenAmp+GSpace)*4-PenAmp);
        end;
      end;
    end;

   with Image.Picture.Bitmap.Canvas do begin
    Brush.Color:=clWhite;
    //Font.Style:=Font.Style + [fsBold];
    TextOut(1,GSpace+PenAmp div 2,'CTS');
    TextOut(1,GSpace*2 +PenAmp+PenAmp div 2,'DSR');
    TextOut(1,GSpace*3 +PenAmp*2+PenAmp div 2,'RI');
    TextOut(1,GSpace*4 +PenAmp*3+PenAmp div 2,'DCD');
   end;


    //
      with Image.Picture.Bitmap.Canvas do begin
        Pen.Width:=2;
        Pen.Color:=clRed;
        PenPos:=Point(Round(TrackBar1.Position*PixPms),0);
        LineTo(Round(TrackBar1.Position*PixPms),Image.Height);

        Pen.Color:=clLime;
        PenPos:=Point(Round(TrackBar2.Position*PixPms),0);
        LineTo(Round(TrackBar2.Position*PixPms),Image.Height);
      end;


    with Image.Picture.Bitmap.Canvas do begin
      Pen.Color:=clBlack;
      Pen.Width:=1;
      Brush.Color:=clWhite;
    end;

    Image.Repaint;

   StatusBar1.Panels[3].Text:=IntToStr(GetTickCount-tmpTime); 
end;

procedure TMainWindow.FormResize(Sender: TObject);
begin
  RenderGraph;
end;

procedure TMainWindow.StartTimerTimer(Sender: TObject);  //  
begin
  StaticText10.Color:=clRed;
  StartTimer.Enabled:=false;
end;

procedure TMainWindow.RenderOnChange(Sender: TObject);
begin
  RenderGraph;
end;

procedure TMainWindow.TrackBarChange(Sender: TObject);
begin
if GridInMCS.Checked then begin
  Label4.Caption:=FloatToStr(TrackBar1.Position)+' ';
  Label5.Caption:=FloatToStr(TrackBar2.Position)+' ';
  Label6.Caption:=FloatToStr(TrackBar2.Position-TrackBar1.Position)+' ';
end
  else begin
    Label4.Caption:=FloatToStr(TrackBar1.Position/1000)+' ';
    Label5.Caption:=FloatToStr(TrackBar2.Position/1000)+' ';
    Label6.Caption:=FloatToStr((TrackBar2.Position-TrackBar1.Position)/1000)+' ';
  end;
  RenderGraph;
end;

procedure TMainWindow.FormCreate(Sender: TObject);
var
  ini:TIniFile;
  s:string;
begin
  // 

  s:=ExtractFilePath(Application.ExeName)+'Digital_Oscilloscope.ini';
  ini:=TIniFile.Create(s);

  PortComboBox.ItemIndex:=ini.ReadInteger('main','com_num',0);
  PortComboBoxChange(PortComboBox);
  CaptureTime.Value:=ini.ReadFloat('main','CaptureTime',10);
  PixPmsSpin.Value:=ini.ReadFloat('main','PixPmsSpin',1);
  PixPmsDiv.Value:=ini.ReadFloat('main','PixPmsDiv',1);
  ShowGrid.Checked:=ini.ReadBool('main','ShowGrid',false);
  VGridCap.Checked:=ini.ReadBool('main','VGridCap',false);
  VGridEven.Checked:=ini.ReadBool('main','VGridEven',false);
  VGridSp.Value:=ini.ReadFloat('main','VGridSp',10);

  HoldRTS.Checked:=ini.ReadBool('main','HoldRTS',false);
  HoldDTR.Checked:=ini.ReadBool('main','HoldDTR',false);
  CBUseTSC.Checked:=ini.ReadBool('main','UseTSC',false);

  CBUseTSCClick(CBUseTSC);

  CTS_Enabled.Checked:=ini.ReadBool('main','ShowCTS',true);
  DSR_Enabled.Checked:=ini.ReadBool('main','ShowDSR',true);
  RI_Enabled.Checked:=ini.ReadBool('main','ShowRI',true);
  DCD_Enabled.Checked:=ini.ReadBool('main','ShowDCD',true);
  CTS_Inv.Checked:=ini.ReadBool('main','InvCTS',false);
  DSR_Inv.Checked:=ini.ReadBool('main','InvDSR',false);
  RI_Inv.Checked:=ini.ReadBool('main','InvRI',false);
  DCD_Inv.Checked:=ini.ReadBool('main','InvDCD',false);

  CTS_Start.Checked:=ini.ReadBool('main','WaitCTS',false);
  DSR_Start.Checked:=ini.ReadBool('main','WaitDSR',false);
  RI_Start.Checked:=ini.ReadBool('main','WaitRI',false);
  DCD_Start.Checked:=ini.ReadBool('main','WaitDCD',true);

  CTSColor.Color:=ini.ReadInteger('colors','CTSColor',0);
  DSRColor.Color:=ini.ReadInteger('colors','DSRColor',0);
  RIColor.Color:=ini.ReadInteger('colors','RIColor',0);
  DCDColor.Color:=ini.ReadInteger('colors','DCDColor',0);

  if ini.ReadString('main','GridIn','mcs')='mcs' then GridInMCS.Checked:=true
    else GridInMS.Checked:=true;

  HighResTimer1.Calibrate(2000);

  if HighResTimer1.UseTSC then StatusBar1.Panels[0].Text:=' TSC: '
    else StatusBar1.Panels[0].Text:=' TSC: ';

  StatusBar1.Panels[1].Text:=' : '+FloatToStr(HighResTimer1.CountSpeed);

  if ini.ReadString('Window','State','wsNormal')<>'wsNormal' then MainWindow.WindowState:=wsMaximized;
end;

procedure TMainWindow.AboutExecute(Sender: TObject);
begin
  AboutForm.ShowModal;
end;

procedure TMainWindow.SaveImgButtonClick(Sender: TObject);
var
  ext:string;
  JImg:TJPEGImage;
  Gif:TGifImage;
begin
  RenderGraph;
  if SavePictureDialog1.Execute then begin
    case SavePictureDialog1.FilterIndex of
      1:ext:='.jpg';
      2:ext:='.jpeg';
      3:ext:='.bmp';
      4:ext:='.gif';
    end;

    if ExtractFileExt(SavePictureDialog1.FileName)='' then
       SavePictureDialog1.FileName:=SavePictureDialog1.FileName+ext;

    if  SavePictureDialog1.FilterIndex=3 then Image.Picture.SaveToFile(SavePictureDialog1.FileName);

    if  (SavePictureDialog1.FilterIndex=1) or (SavePictureDialog1.FilterIndex=2) then begin
      JImg:=TJPEGImage.Create;
      JImg.Assign(Image.Picture.Bitmap);
      JImg.SaveToFile(SavePictureDialog1.FileName);
      JImg.Free;
    end;

    if SavePictureDialog1.FilterIndex=4 then begin
      Gif:=TGIFImage.Create;
      Gif.Assign(Image.Picture.Bitmap);
      Gif.OptimizeColorMap;
      Gif.SaveToFile(SavePictureDialog1.FileName);
      Gif.Free;
    end;

  end
end;

procedure TMainWindow.FormClose(Sender: TObject; var Action: TCloseAction);
var
  ini:TIniFile;
  s:string;
begin
  s:=ExtractFilePath(Application.ExeName)+'Digital_Oscilloscope.ini';
// 
  ini:=TIniFile.Create(s);
  ini.WriteInteger('main','com_num',PortComboBox.ItemIndex);
  ini.WriteFloat('main','CaptureTime',CaptureTime.Value);
  ini.WriteFloat('main','PixPmsSpin',PixPmsSpin.Value);
  ini.WriteFloat('main','PixPmsDiv',PixPmsDiv.Value);
  ini.WriteBool('main','ShowGrid',ShowGrid.Checked);
  ini.WriteBool('main','VGridCap',VGridCap.Checked);
  ini.WriteBool('main','VGridEven',VGridEven.Checked);
  ini.WriteFloat('main','VGridSp',VGridSp.Value);

  ini.WriteBool('main','HoldRTS',HoldRTS.Checked);
  ini.WriteBool('main','HoldDTR',HoldDTR.Checked);
  ini.WriteBool('main','UseTSC',CBUseTSC.Checked);

  ini.WriteBool('main','ShowCTS',CTS_Enabled.Checked);
  ini.WriteBool('main','ShowDSR',DSR_Enabled.Checked);
  ini.WriteBool('main','ShowRI',RI_Enabled.Checked);
  ini.WriteBool('main','ShowDCD',DCD_Enabled.Checked);
  ini.WriteBool('main','InvCTS',CTS_Inv.Checked);
  ini.WriteBool('main','InvDSR',DSR_Inv.Checked);
  ini.WriteBool('main','InvRI',RI_Inv.Checked);
  ini.WriteBool('main','InvDCD',DCD_Inv.Checked);

  ini.WriteBool('main','WaitCTS',CTS_Start.Checked);
  ini.WriteBool('main','WaitDSR',DSR_Start.Checked);
  ini.WriteBool('main','WaitRI',RI_Start.Checked);
  ini.WriteBool('main','WaitDCD',DCD_Start.Checked);

  ini.WriteInteger('colors','CTSColor',CTSColor.Color);
  ini.WriteInteger('colors','DSRColor',DSRColor.Color);
  ini.WriteInteger('colors','RIColor',RIColor.Color);
  ini.WriteInteger('colors','DCDColor',DCDColor.Color);

  if GridInMCS.Checked then ini.WriteString('main','GridIn','mcs')
    else ini.WriteString('main','GridIn','ms');

  if MainWindow.WindowState=wsMaximized then ini.WriteString('Window','State','wsMaximized')
    else ini.WriteString('Window','State','wsNormal')
end;

procedure TMainWindow.CaptureTimeChange(Sender: TObject);
begin
  MeasureTime:=round(CaptureTime.Value);
end;

procedure TMainWindow.PortComboBoxChange(Sender: TObject);
begin
  case PortComboBox.ItemIndex of
    0:Base:=$03F8;
    1:Base:=$02F8;
    2:Base:=$03E8;
    3:Base:=$02E8;
  end;
  AdrText.Caption:=IntToHex(Base,4);
end;

procedure TMainWindow.AdrButtonClick(Sender: TObject);
var
  S:string;
  B:word;
  Code:integer;
begin
  S:=InputBox(' ','     ','$03F8');
  Val(S,B,Code);
  if code = 0 then begin
    Base:=B;
    AdrText.Caption:=IntToHex(Base,4);
  end
    Else MessageBox(Handle,' ','',MB_OK or MB_ICONERROR);
end;

procedure TMainWindow.CBUseTSCClick(Sender: TObject);
begin
  HighResTimer1.UseTSC:=CBUseTSC.Checked;
  if HighResTimer1.UseTSC then StatusBar1.Panels[0].Text:=' TSC: '
    else StatusBar1.Panels[0].Text:=' TSC: ';
  StatusBar1.Panels[1].Text:=' : '+FloatToStr(HighResTimer1.CountSpeed);
end;

procedure TMainWindow.DCDColorClick(Sender: TObject);
begin
  If ColorDialog.Execute = true then begin
    (Sender as TRzToolButton).Color:=colorDialog.Color;
    RenderGraph;
  end;
end;

procedure TMainWindow.ImageMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  PixPms:single;
begin
  PixPms:=PixPmsSpin.Value/PixPmsDiv.Value;
  if Button=mbLeft then TrackBar1.Position:=Round(X/PixPms);
  if Button = mbRight then TrackBar2.Position:=Round(X/PixPms);
end;

procedure TMainWindow.ImageMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
  PixPms:single;
begin
  PixPms:=PixPmsSpin.Value/PixPmsDiv.Value;
  if ssLeft in Shift then TrackBar1.Position:=Round(X/PixPms);
  if ssRight in Shift then TrackBar2.Position:=Round(X/PixPms);
end;

procedure TMainWindow.TimeSelectorClick(Sender: TObject);
begin
  TrackBarChange(Sender);
  RenderGraph;
end;

procedure TMainWindow.SaveImageExecute(Sender: TObject);
begin
  SaveImgButtonClick(Sender);
end;

end.
